## 各种坑

---

#### 1. SimpleDateFormat 不是线程安全的

使用过程不要定义为静态全局变量。

**正确使用：**

```
    /**
     * 时间是否是今天
     */
    public static boolean isToday(Long second) {
        if (second == null) {
            return false;
        }
        SimpleDateFormat sf = new SimpleDateFormat("yyyy-MM-dd");
        String today = sf.format(System.currentTimeMillis());
        String compare = sf.format(new Date(second * 1000L));
        return StringUtils.equals(today, compare);
    }
    
```


#### 2.cache模型里面字段数据范围
通常预发环境和线上环境会共用一套cache，如何避免两套环境间的数据干扰。

```
写入：DO --> cacheModel
读出：cacheModel --> DO
查询接口：DO --> ServiceModel
```
#### 3.